﻿using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using OAI.Server.Catalog;

namespace OAI {
	public interface IOAIHandler {
		void Reload();
		bool SupportsMetadataPrefix(string metadataPrefix);
		Record GetRecord(string identifier, string metadataPrefix, DateTime buildDate);
		IEnumerable<string> GetIdentifyAdminEmails();
		IEnumerable<string> GetCustomIdentifyDescriptions();
		string GetRepositoryName();
		IdentifiersList GetIdentifiersList(string from, string until, string set, string metadataPrefix);
		IdentifiersList GetIdentifiersList(string resumptionToken);
		List<MetadataFormat> GetAllMetadataFormats();
		RecordsList GetRecordsList(string from, string until, string set, string metadataPrefix, DateTime buildDate);
		RecordsList GetRecordsList(string resumptionToken, DateTime buildDate);
		SetsList ListSets();
		SetsList ListSets(string resumptionToken);
		NameValueCollection GetQuery();
		string GetBaseURL();
		string GetIdentifyEarliestDatestamp();
		string GetDeletedRecord();
		string GetIdentifyPrefix();
		string GetGranularity();
	}
}
