﻿select Resources.Identifier as Identifier, ${fields} from (
	select
		location_resource.parent_mis_objectid as Identifier, 
		case location_resource.category
			when 0 then 'Föremålsexempel'
			when 1 then
				case
					when location_resource.mis_class = 'L' then 'Fyndlokal'
					when location_resource.mis_class is null and location_resource.external_class = '1.0' then 'Fornlämning'
					when location_resource.mis_class is null and location_resource.external_class = '1.1' then 'Bebyggelseobjekt'
				end
			when 3 then
				case
					when location_resource.mis_class = 'D' then 'Bildreferens till MIS'
					when location_resource.external_class = '3.0' then 'Bildreferens till Kulturmiljöbild'
				end
			when 6 then
				case when location_resource.external_class = '6.0' then 'Litteraturreferens till Libris' end
		end as type,
		case location_resource.category
			when 0 then cast(location_resource.mis_objectid as varchar)
			when 1 then
				case
					when location_resource.mis_class = 'L' then cast(location_resource.mis_objectid as varchar)
					when location_resource.mis_class is null and location_resource.external_class = '1.0' then location_resource.external_id
					when location_resource.mis_class is null and location_resource.external_class = '1.1' then location_resource.external_id
				end
			when 3 then
				case
					when location_resource.mis_class = 'D' then cast(location_resource.mis_objectid as varchar)
					when location_resource.external_class = '3.0' then location_resource.external_id
				end
			when 6 then
				case when location_resource.external_class = '6.0' then location_resource.external_id end
		end as id
	from location_resource
	where location_resource.parent_mis_class = 'Z' and location_resource.parent_mis_objectid in (${headers})
) as Resources
where Resources.type is not null and Resources.id is not null