﻿using System.Collections.Generic;
using System.Diagnostics;

namespace ServiceCore.ServiceComponents
{
	public class AdditionalOutput : Output {
		public string Id { get; private set; }
		public List<string> OrderedDataKeys { get; private set; }
		public Dictionary<string, NamedData> Data { get; private set; }
		public string Delimiter { get; private set; }

		public AdditionalOutput(string id, string template, string delimiter) {
			Id = id;
			Template = template; 
			OrderedDataKeys = new List<string>();
			Data = new Dictionary<string, NamedData>();
			Delimiter = delimiter;
#if DEBUG
			//Debug.WriteLine(string.Format("Additional Output: {0}", id));
#endif
		}
	}
}