﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Text;
using OAI.Util;

namespace ServiceCore.ServiceComponents
{
	public class MinValue : NamedData {
		public List<NamedData> Sources { get; private set; }
		public string ValueType { get; private set; }

		public MinValue(string id, List<NamedData> sources, string valueType) {
			Id = id;
			Sources = sources;
			ValueType = valueType;
#if DEBUG
			//Debug.WriteLine(string.Format("MinValue: {0}", id));
#endif
		}

		public override string GetValue(IDictionary<string, string> templates, IDictionary<string, string> values) {
			var min = "";
			switch (ValueType) {
				case "date":
					{
						foreach (var data in Sources) {
							try
							{
								var date = DateTime.Parse(data.GetValue(templates, values));
								if (min == "" || DateTime.Parse(min) > date)
									min = date.ToString("yyyy-MM-dd");
							} catch (Exception) {

							}
						}
					}
					break;
				case "int":
					{
						foreach (var data in Sources) {
							try
							{
								var value = int.Parse(data.GetValue(templates, values));
								if (min == "" || int.Parse(min) > value)
									min = value.ToString();
							} catch (Exception)
							{
								
							}
						}
					}
					break;
				case "long": {
						foreach (var data in Sources) {
							try
							{
								var value = long.Parse(data.GetValue(templates, values));
								if (min == "" || long.Parse(min) > value)
									min = value.ToString();
							} catch (Exception)
							{
								
							}

						}
					}
					break;
				case "float": {
						foreach (var data in Sources) {
							try
							{
								var value = float.Parse(data.GetValue(templates, values));
								if (min == "" || float.Parse(min) > value)
									min = value.ToString();
							} catch (Exception)
							{
								
							}

						}
					}
					break;
				case "double": {
						foreach (var data in Sources) {
							try
							{
								var value = double.Parse(data.GetValue(templates, values));
								if (min == "" || double.Parse(min) > value)
									min = value.ToString();
								} catch (Exception)
							{
								
							}

						}
					}
					break;
			}

			values[Id] = min;

			return OAIUtil.XmlEncode(values[Id]);
		}
	}
}