﻿using System.Collections.Generic;
using System.Diagnostics;
using ServiceCore.ServiceComponents;

namespace ServiceCore.ServiceComponents
{
	public class Service {
		public string Id { get; private set; }
		public string Name { get; private set; }
		public string Institution { get; private set; }
		public int CommandTimeout { get; private set; }
		public Connection Connection { get; private set; }
		public Dictionary<string, ProtocolDescription> Descriptions { get; private set;  }
		public int UpdateRate { get; private set; }
		public int ResultBlock { get; private set; }
		public string DeletedRecord { get; private set; }
		public string EarliestDatestamp { get; private set; }
		public string IdentifyPrefix { get; private set; }
		public string IdentifierType { get; private set; }

		public Service(string id, string name, string institution, Connection connection, int updateRate, int resultBlock, string deletedRecord, string earliestDatestamp, string identifyPrefix, int commandTimeout, string identifierType) {
			Id = id.ToLower();
			Name = name;
			CommandTimeout = commandTimeout;
			Institution = institution.ToLower();
			Connection = connection;
			Descriptions = new Dictionary<string, ProtocolDescription>();
			UpdateRate = updateRate;
			ResultBlock = resultBlock;
			DeletedRecord = deletedRecord;
			EarliestDatestamp = earliestDatestamp;
			IdentifyPrefix = identifyPrefix;
			IdentifierType = identifierType;
#if DEBUG
			//Debug.WriteLine(string.Format("Service: {0}", id));
#endif
		}
	}
}